﻿
package 
{


import flash.display.BlendMode;
import flash.display.Sprite;
import flash.events.Event;
import flash.events.MouseEvent;
import flash.geom.Point;
import flash.geom.Rectangle;

public class GripBox extends Sprite {
	
	public static const GRABBED:String = "grabbed";
	public static const EDITED:String = "edited";
	public static const RELEASED:String = "released";
	
	public var size:Number;
	
	public function GripBox(_x:Number=0.0, _y:Number=0.0, _size:Number=12.0) {
		this.x=_x;
		this.y=_y;
		this.size = _size;
		
		boxOff();
		
		this.addEventListener(MouseEvent.MOUSE_DOWN, grabBox);
		this.addEventListener(MouseEvent.MOUSE_UP, releaseBox);
		
		// this.blendMode = flash.display.BlendMode.DIFFERENCE;
	}
	
	public function grabBox(evt:MouseEvent):void {
		
		boxOn();
		this.startDrag();
		this.addEventListener(Event.ENTER_FRAME, moveBox);
		if (hasEventListener(GripBox.GRABBED)) dispatchEvent(new Event(GripBox.GRABBED));
	}
	
	private function boxOn():void {
		with (this.graphics) {
			clear();
			lineStyle(2,0xD20000);
			beginFill(0xD20000,0.5);
			drawRect(-size/2,-size/2,size,size);
		}
	}

	private function boxOff():void {
		with (this.graphics) {
			clear();
			lineStyle(2,0x0000CC);
			beginFill(0x0,0.0);
			drawRect(-size/2,-size/2,size,size);
		}
	}
	
	
	public function releaseBox(evt:MouseEvent):void {
		this.stopDrag();
		this.removeEventListener(Event.ENTER_FRAME, moveBox);
		boxOff();
		if (hasEventListener(GripBox.RELEASED)) dispatchEvent(new Event(GripBox.RELEASED));
	}
	
	public function moveBox(evt:Event):void {
		this.x = parent.mouseX;
		this.y = parent.mouseY;
		if (hasEventListener(GripBox.EDITED)) dispatchEvent(new Event(GripBox.EDITED));
	}
	
	public function moveTo(_x:Number,_y:Number):void {
		this.x=_x;
		this.y=_y;
	}
	public function moveToPoint(p:Point):void {
		this.x=p.x;
		this.y=p.y;
	}
	
	public override function toString():String {
		return "GripBox:(" + x + "," + y+")";
	}
	
	public function get point():Point {
		return new Point(this.x,this.y);
	}
	public function set point(p:Point):void {
		this.x= p.x;
		this.y= p.y;
	}
	
	
}
}